/*
 * Date.h
 *
 */

#ifndef DATE_H_
#define DATE_H_

#include <iostream>

class Date {
public:
	Date(int day=1, int month=1, int year=1970);
	virtual ~Date();
	friend std::ostream& operator<<(std::ostream& out, const Date& rhs);

	int getDay() const {
		return day;
	}
	int getMonth() const {
		return month;
	}
	int getYear() const {
		return year;
	}

private:
	int day, month, year;
};

std::ostream& operator<<(std::ostream& out, const Date& rhs);

class DateComparator {
public:
	bool operator()(const Date& lhs, const Date& rhs) const {
		if (lhs.getYear() < rhs.getYear())
			return true;
		if (lhs.getYear() == rhs.getYear()) {
			if (lhs.getMonth() < rhs.getMonth())
				return true;
			if (lhs.getMonth() == rhs.getMonth()) {
				if (lhs.getDay() < rhs.getDay())
					return true;
				else
					return false;
			} else
				return false;
		} else
			return false;
	}
};

#endif /* DATE_H_ */
