/*
 * DateMultiMap.cpp
 *
 */

#include <string>
#include <map>
#include <iostream>

#include "Date.h"

int main() {
	Date d1(25, 6, 1970);
	Date d2(12, 4, 2008);
	Date d3(5, 6, 2011);

	std::multimap<Date, std::string, DateComparator> compleanni;

	compleanni.insert(std::pair<Date, std::string>(d3, "aurelio"));
	compleanni.insert(std::pair<Date, std::string>(d1, "marco"));
	compleanni.insert(std::pair<Date, std::string>(d2, "giulio"));

	Date d4(1, 1, 2009);
	Date d5(1, 1, 1970);
	std::multimap<Date, std::string>::iterator it, itLow, itUp;
	itUp = compleanni.upper_bound(d4);
	itLow = compleanni.lower_bound(d5);

	std::cout << "Compleanni tra " << d5 << " e " << d4 << std::endl;
	// print range [itlow,itup):
	for (it = itLow; it != itUp; it++)
		std::cout << (*it).first << " => " << (*it).second << std::endl;

	return 0;
}
